/**
 * Der Abschluss einer allgemeinen Liste.
 * 
 * @author Bernd Gramlich
 * @version 2012-11-30
 */
public class Abschluss extends Listenelement
{
    /**
     * Konstruktor.
     * Der Abschluss der Liste enthlt nichts.
     * Deshalb braucht auch nichts getan zu werden.
     */
    public Abschluss ()
    {
    }

    /**
     * Nenne meinen Nachfolger.
     * Mein Nachfolger ist null, da ich der
     * Abschluss der Liste bin.
     */
    public Listenelement gibNachfolger ()
    {
        return null;
    }

    /**
     * Nenne meinen Inhalt.
     * Mein Inhalt ist null, da ich der
     * Abschluss der Liste bin.
     */
    public Eintrag gibInhalt ()
    {
        return null;
    }

    /**
     * Fge hinten an die Liste einen Knoten mit dem neuen
     * Eintrag an.
     * 
     * Da ich der Abschluss bin, erzeuge ich einen neuen
     * Knoten mit mir als Nachfolger. Den Verweis auf mich
     * selbst erziele ich durch das Java-Schlsselwort "this".
     */
    public Listenelement fuegeHintenAn (Eintrag neuerEintrag)
    {
        return new Knoten (this, neuerEintrag);
    }
    
    /**
     * Fge einen neuen Eintrag aufsteigend sortiert in die Liste ein.
     * 
     * Da ich der Abschluss bin, erzeuge ich einen neuen
     * Knoten mit mir als Nachfolger. Den Verweis auf mich
     * selbst erziele ich durch das Java-Schlsselwort "this".
     */
    public Listenelement fuegePassendEin (Eintrag neuerEintrag)
    {
        return new Knoten (this, neuerEintrag);
    }

    /**
     * Nenne die Lnge der Schlange von mir selbst ab.
     */
    public int gibLaenge ()
    {
        return 0;
    }

    /**
     * Verschiebe den Knoten und alle seine Nachfolger 
     * graphisch nach links.
     */
    public void verschiebeNachLinks ()
    {
    }

    /**
     * Verschiebe den Knoten und alle seine Nachfolger
     * graphisch nach rechts.
     */
    public void verschiebeNachRechts ()
    {
    }
    
    /**
     * Drucke den Inhalt der Liste ab mir selbst auf die
     * Konsole.
     */
    public void druckeAufKonsole ()
    {
    }
}
