/**
 * Der Dateneintrag in einer Liste.
 * Diese Schnittstelle enthlt Methoden, mit denen die Eintrge
 * einer Liste sowohl graphisch veranschaulicht als auch
 * nichtgraphisch verwaltet werden knnen.
 * 
 * @author Bernd Gramlich 
 * @version 2015-12-02
 */
public interface Eintrag
{
    /*
     * Zwischen den Koordinaten zweier graphisch dargestellter
     * aufeinanderfolgender Listeneintrge besteht folgender
     * Unterschied in x- bzw. y-Richtung.
     */
    int xVerschiebung = 100;
    int yVerschiebung = 0;
    
    /**
     * Verschiebe den Eintrag um eine Stelle nach rechts in der
     * Liste.
     */
    void verschiebeNachRechts ();
    
    /**
     * Verschiebe den Eintrag um eine Stelle nach links in der
     * Liste.
     */
    void verschiebeNachLinks ();
    
    /**
     * Mache den Eintrag graphisch unsichtbar.
     */
    void werdeUnsichtbar ();
    
    /**
     * Gib an, ob dieser Eintrag kleiner als ein anderer Eintrag ist.
     * 
     * @return true, falls der Eintrag kleiner als "andererEintrag" ist.
     *         false, falls der Eintrag grer oder gleich
     *         "andererEintrag" ist oder falls die beiden Eintrge nicht
     *         vergleichbar sind.
     */
    boolean istKleinerAls (Eintrag andererEintrag);
    
    /**
     * Drucke den Eintrag auf die Konsole.
     */
    void druckeAufKonsole ();
}
