/**
 * Ein Element einer Liste.
 * Die Klasse ist abstrakt, da ein Listenelement
 * entweder ein Knoten (mit Daten) oder der Abschluss
 * der Liste sein kann.
 * 
 * @author Bernd Gramlich 
 * @version 2012-11-30
 */
public abstract class Listenelement
{
    /*
     * Die Klasse selbst hat keinen Konstruktor, sondern nur
     * ihre Unterklassen.
     */
    
    /**
     * Nenne den Nachfolger des Listenelements.
     */
    public abstract Listenelement gibNachfolger ();

    /**
     * Nenne den Inhalt des Listenelements.
     */
    public abstract Eintrag gibInhalt ();
    
    /**
     * Fuege hinten an die Liste ein neues Listenelement an.
     */
    public abstract Listenelement fuegeHintenAn (Eintrag neuerEintrag);
    
    /**
     * Fge einen neuen Eintrag aufsteigend sortiert in die Liste ein.
     */
    public abstract Listenelement fuegePassendEin (Eintrag neuerEintrag);

    /**
     * Nenne die Lnge der Liste von mir selbst ab.
     */
    public abstract int gibLaenge ();

    /**
     * Verschiebe das Listenelement und alle seine Nachfolger 
     * graphisch nach links.
     */
    public abstract void verschiebeNachLinks ();

    /**
     * Verschiebe das Listenelement und alle seine Nachfolger
     * graphisch nach rechts.
     */
    public abstract void verschiebeNachRechts ();

    /**
     * Drucke den Inhalt der Liste ab mir selbst auf die
     * Konsole.
     */
    public abstract void druckeAufKonsole ();
}
