/**
 * Eine Fremdsprachenvokabel.
 * 
 * @author Bernd Gramlich
 * @version 2012-11-30
 */
public class Vokabel
{
    private String fremd;
    private String deutsch;

    /**
     * Konstruktor.
     * Erzeuge aus "fremdeBedeutung" und "deutscheBedeutung"
     * eine neue Vokabel.
     */
    public Vokabel (String fremdeBedeutung, String deutscheBedeutung)
    {
        fremd   = fremdeBedeutung;
        deutsch = deutscheBedeutung;
    }
    
    /**
     * Nenne die fremdsprachige Bedeutung der Vokabel.
     */
    public String gibFremd ()
    {
        return fremd;
    }
    
    /**
     * Nenne die deutsche Bedeutung der Vokabel.
     */
    public String gibDeutsch ()
    {
        return deutsch;
    }
    
    /**
     * ndere die fremdsprachige Bedeutung der Vokabel.
     */
    public void setzeFremd (String fremdeBedeutung)
    {
        fremd = fremdeBedeutung;
    }
    
    /**
     * ndere die deutsche Bedeutung der Vokabel.
     */
    public void setzeDeutsch (String deutscheBedeutung)
    {
        deutsch = deutscheBedeutung;
    }
    
    /**
     * Erzeuge eine zufllige Englischvokabel.
     */
    public static Vokabel erzeugeZufaellig ()
    {
        int zufall;
        String fremdeBedeutung;
        String deutscheBedeutung;

        zufall = (int) Math.floor (3 * Math.random ());

        switch (zufall)
        {
            case 0:
            fremdeBedeutung   = "class";
            deutscheBedeutung = "Klasse";
            break;
            case 1:
            fremdeBedeutung   = "abstract";
            deutscheBedeutung = "abstrakt";
            break;
            default:
            fremdeBedeutung   = "interface";
            deutscheBedeutung = "Schnittstelle";
            break;
        }
        
        return new Vokabel (fremdeBedeutung, deutscheBedeutung);
    }
}
